<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */
// +----------------------------------------------------------------------+
// | PHP version 4/5                                                      |
// +----------------------------------------------------------------------+
// | This source file is a part of iScripts Multicart                     |
// +----------------------------------------------------------------------+
// | Authors: Programmer<programmer@armia.com>        		              |
// +----------------------------------------------------------------------+
// | Copyrights Armia Systems, Inc and iScripts.com  2005                |
// | All rights reserved                                                  |
// +----------------------------------------------------------------------+
// | This script may not be distributed, sold, given away for free to     |
// | third party, or used as a part of any internet services such as      |
// | webdesign etc.                                                       |
// +----------------------------------------------------------------------+

function GetSQLValueString($theValue, $theType, $theDefinedValue = "", $theNotDefinedValue = "") 
{
  $theValue = (!get_magic_quotes_gpc()) ? addslashes($theValue) : $theValue;

  switch ($theType) {
	case "text":
	  $theValue = ($theValue != "") ? "'" . $theValue . "'" : "''";
	  break;    
	case "long":
	case "int":
	  $theValue = ($theValue != "") ? intval($theValue) : "''";
	  break;
	case "double":
	  $theValue = ($theValue != "") ? "'" . doubleval($theValue) . "'" : "''";
	  break;
	case "date":
	  $theValue = ($theValue != "") ? "'" . $theValue . "'" : "''";
	  break;
	case "defined":
	  $theValue = ($theValue != "") ? $theDefinedValue : $theNotDefinedValue;
	  break;
  }
  return $theValue;
}


/*----------function to get the seller rating count---------------*/

function getSellerRating($rating_id,$seller_id)
{
global $tableprefix;

	$select_rating = "SELECT COUNT(nrating_id) AS rating_count 
					  FROM ".$tableprefix."record_ratings
					   WHERE nrating_id = ".$rating_id.
					   " AND nrseller_id = ".$seller_id;
	$result_rating = mysql_query($select_rating) or die(mysql_error());
	
	if(mysql_num_rows($result_rating) > 0)
	{
		$rating_count_row = mysql_fetch_assoc($result_rating); 
	}				   

return $rating_count_row['rating_count']; 
}






/*----------function to check whether the seller gift certiicate is used to purchase only his products---------------*/


function checkGiftCertificateSeller($certificate_code)
{
global $_SESSION,$tableprefix;
	
	
	$gift_certificate_flag = 0;
	
	$select_cart_products = "SELECT product_id FROM ".$tableprefix."cart 
							 WHERE user_id = ".$_SESSION['sess_userid'];
							 
	//echo $select_cart_products."<br>";				 
							 
	$result_cart_products = mysql_query($select_cart_products) or die(mysql_error());
	
	if(mysql_num_rows($result_cart_products) > 0)
	{
	
		while($cart_row = mysql_fetch_array($result_cart_products))
		{
		
			
/*----------selecting the seller------------*/			

			$cart_product_seller = getSellerName($cart_row['product_id']);
			
			
/*---------------------------------*/

			$select_gift_certificate = "SELECT ngift_product_id
								FROM ".$tableprefix."giftcoupon_master 
								WHERE vgift_coupon_code = '".$certificate_code."'";
										
			//echo $select_gift_certificate."<br>";							
			 
			$result_gift_certificate = mysql_query($select_gift_certificate) or die(mysql_error());
			
			if(mysql_num_rows($result_gift_certificate) > 0)
			{
				
				$gift_certificate_seller_row = mysql_fetch_assoc($result_gift_certificate);
				
				$gift_certificate_seller = getSellerName($gift_certificate_seller_row['ngift_product_id']);				
				
			}
			
			
			if($cart_product_seller != $gift_certificate_seller)
			{
				$gift_certificate_flag = 1;
				
				break;
				
			}			
			
			
/*--------------------------------------*/			
			
										
		}
	
	}
	
	
	
	
return $gift_certificate_flag;
}


function getSellerName($product_id)
{
global $tableprefix;

	
	$select_seller_product = "SELECT product_artist_id FROM ".$tableprefix."products 
							  WHERE product_id = ".$product_id;
	$result_seller_product = mysql_query($select_seller_product) or die(mysql_error());	

	if(mysql_num_rows($result_seller_product) > 0)
	{
		$seller_product_row = mysql_fetch_assoc($result_seller_product);		
	}
	
return $seller_product_row['product_artist_id']; 	
}

/*----------function to check whether the seller gift certiicate is used to purchase only his products---------------*/


/*--------function to get the country name-----------------
	paramter is country code
*/


function getCountryName($country_code)
{
global $tableprefix;

	$select_country = "SELECT country_name FROM ".$tableprefix."countries 
						WHERE country_iso_code_2 = '".$country_code."'";
	$result_country = mysql_query($select_country) or die(mysql_error());					

	if(mysql_num_rows($result_country) > 0)
	{
		$country_row = mysql_fetch_assoc($result_country);	
		
		$country_name = $country_row['country_name'];
	}

return $country_name; 

}



/*-------function to manage the user/admin/seller/affiliate sessions-----------*/



function manageSession($category)
{
global $_SESSION;

/*
	1 - Admin
	2 - Seller
	3 - User
	4 - Affiliate 
*/
	
	if($category == 1) // Admin Category
	{
		if($_SESSION['sess_affiliateid'] != "")
		{
			$_SESSION['sess_affiliateid'] = "";
		}	
		if($_SESSION['sess_artistid'] != "")
		{
			$_SESSION['sess_artistid'] = "";
		}
		if($_SESSION['sess_userid'] != "")
		{
			$_SESSION['sess_userid'] = "";
		}			
	}
	else if($category == 2) // Seller Category
	{
		if($_SESSION['sess_affiliateid'] != "")
		{
			$_SESSION['sess_affiliateid'] = "";
		}	
		if($_SESSION['sess_adminname'] != "")
		{
			$_SESSION['sess_adminname'] = "";
		}
		if($_SESSION['sess_userid'] != "")
		{
			$_SESSION['sess_userid'] = "";
		}			
	}
	else if($category == 3) // User Category
	{
		if($_SESSION['sess_affiliateid'] != "")
		{
			$_SESSION['sess_affiliateid'] = "";
		}	
		if($_SESSION['sess_adminname'] != "")
		{
			$_SESSION['sess_adminname'] = "";
		}
		if($_SESSION['sess_artistid'] != "")
		{
			$_SESSION['sess_artistid'] = "";
		}			
	}
	else if($category == 4) // Affiliate Category
	{
		if($_SESSION['sess_artistid'] != "")
		{
			$_SESSION['sess_artistid'] = "";
		}	
		if($_SESSION['sess_adminname'] != "")
		{
			$_SESSION['sess_adminname'] = "";
		}
		if($_SESSION['sess_userid'] != "")
		{
			$_SESSION['sess_userid'] = "";
		}		
	}
}



/*------function to read the email templates-----------*/


function readEmailTemplate($template_name,$table_name="",$email_address="")
{
global $tableprefix,$_SESSION;

	$select_email_template = "SELECT vemail_body FROM ".$tableprefix."email_templates WHERE vtemplate_name = '".$template_name."'";
			
	$result_email_template = mysql_query($select_email_template) or die(mysql_error());
	
	if($email_address != "")
	{
	
		$select_user_details = "SELECT first_name,last_name FROM ".$tableprefix."users 
								WHERE email = '".$email_address."'";
								
		$result_user_details = mysql_query($select_user_details) or die(mysql_error());		
		
		if(mysql_num_rows($result_user_details) > 0)
		{
		
			$user_details_row = mysql_fetch_assoc($result_user_details);
			
			$txtFirstName = $user_details_row['first_name'];
			$txtLastName = $user_details_row['last_name'];
		}					
		
	
	}
	
	
	if($table_name == "" && $email_address == "")
	{
	
		$select_user_details = "SELECT first_name,last_name FROM ".$tableprefix."users 
								WHERE user_id = ".$_SESSION["sess_userid"];
								
		$result_user_details = mysql_query($select_user_details) or die(mysql_error());		
		
		if(mysql_num_rows($result_user_details) > 0)
		{
		
			$user_details_row = mysql_fetch_assoc($result_user_details);
			
			$txtFirstName = $user_details_row['first_name'];
			$txtLastName = $user_details_row['last_name'];
		}					
	}
	else
	{
	
		if($table_name == "artists")
		{
			$select_user_details = "SELECT first_name,last_name FROM ".$tableprefix."artists 
									WHERE artist_id = ".$_SESSION["sess_artistid"];
								
			$result_user_details = mysql_query($select_user_details) or die(mysql_error());		
			
			if(mysql_num_rows($result_user_details) > 0)
			{
			
				$user_details_row = mysql_fetch_assoc($result_user_details);
				
				$txtFirstName = $user_details_row['first_name'];
				$txtLastName = $user_details_row['last_name'];
			}					
		
		}
		else if($table_name == "affiliates")
		{
		
			$select_user_details = "SELECT first_name,last_name FROM ".$tableprefix."affiliates 
									WHERE affiliate_id = ".$_SESSION["sess_affiliateid"];
								
			$result_user_details = mysql_query($select_user_details) or die(mysql_error());		
			
			if(mysql_num_rows($result_user_details) > 0)
			{
			
				$user_details_row = mysql_fetch_assoc($result_user_details);
				
				$txtFirstName = $user_details_row['first_name'];
				$txtLastName = $user_details_row['last_name'];
			}					
		
		}
	
	
	}
	if(mysql_num_rows($result_email_template) > 0)
	{
	
		$email_template_row = mysql_fetch_assoc($result_email_template);
		$email_body = $email_template_row['vemail_body']; 
		$email_body = str_replace('[first_name]',$txtFirstName,$email_body);
		$email_body = str_replace('[last_name]',$txtLastName,$email_body);
		$email_body = str_replace('[site_name]',SITE_NAME,$email_body);
	
	}	
	
return $email_body; 
}

/*------function to read the email templates-----------*/




/*-----function to replace the pattern in the css files-----*/



function showRegForm($sample_filename,$sample_fields="")
{

	

		$sample_handle = fopen($sample_filename, "r");
		
		if(filesize($sample_filename)>0)
		{
		$sample_contents = fread($sample_handle, filesize($sample_filename));
		}
		else
		{
		$sample_contents = "";
		}
		if ($sample_fields=='')
		{
				$sample_fields['dd']='';
		}
		foreach($sample_fields as $sample_key => $sample_value)
		{
				$sample_contents=str_replace("--$sample_key--",$sample_value,$sample_contents);
		}

		$sample_pattern = "/--(\w+)--/i";
		$sample_contents=preg_replace($sample_pattern, "", $sample_contents);
		fclose($sample_handle);
return $sample_contents;
}






/*----------function to display the content management details----------*/

function displayCMS($cms_name)
{
global $tableprefix;

	$cms_array = array();

	$select_cms = "SELECT content_heading,content_text FROM ".$tableprefix."content_management 
				   WHERE content_name = ".GetSQLValueString($cms_name,"text");
	$result_cms = mysql_query($select_cms);			
	
	if(mysql_num_rows($result_cms) > 0)  
	{
		
		$cms_row = mysql_fetch_assoc($result_cms);
		array_push($cms_array,$cms_row['content_heading'],$cms_row['content_text']); 
	
	} 
	
return $cms_array;
}




/*------function to hide the shipping when cart contains digital product or gift coupon----*/


function hideShipping()
{
global $tableprefix,$_SESSION;
	
	$hide_shipping_division = 0;

	$select_cart_digital = "SELECT ct.cart_id FROM ".$tableprefix."cart ct,".$tableprefix."products prd
							WHERE ct.product_id = prd.product_id
						 	AND vdigital_product = 'Y'
						 	AND ct.user_id = ".$_SESSION["sess_userid"];
								 
	$result_cart_digital = mysql_query($select_cart_digital) or die(mysql_error());		
									 
	$select_cart_gift = "SELECT ct.cart_id FROM ".$tableprefix."cart ct,".$tableprefix."products prd,".$tableprefix."categories ctry
						  WHERE ct.product_id = prd.product_id
						   AND prd.product_category = ctry.category_id 
						   AND ctry.gift_certificate_flag = 'Y'
						   AND ct.user_id = ".$_SESSION["sess_userid"];		
						   
	$result_cart_gift = mysql_query($select_cart_gift) or die(mysql_error());
	
	if(mysql_num_rows($result_cart_digital) == 0 && mysql_num_rows($result_cart_gift) == 0)
	{
	
		$hide_shipping_division = 1;
	
	}

return $hide_shipping_division;
}









function cartClearDigital()
{
global $_SESSION,$tableprefix;


	$select_gift_check = "SELECT crt.cart_id
						  FROM ".$tableprefix."categories ctry,".$tableprefix."cart crt,".$tableprefix."products prd
						   WHERE ctry.category_id = prd.product_category 
						    AND crt.product_id = prd.product_id
							AND ctry.gift_certificate_flag != 'Y' 
							AND  prd.vdigital_product != 'Y'
							GROUP BY crt.cart_id";
				
	$result_gift_check = mysql_query($select_gift_check) or die(mysql_error());						

	if(mysql_num_rows($result_gift_check) > 0)
	{
	 	$clear_cart = "DELETE FROM ".$tableprefix."cart WHERE cart_id != ".$_SESSION['SESS_card_id'];
		mysql_query($clear_cart) or die(mysql_error());
	}
	
	
}


/*function to extract the extension of a file*/

function findexts($filename)
{
	$filename = strtolower($filename) ;
	$exts = split("[/\\.]", $filename) ;
	$n = count($exts)-1;
	$exts = $exts[$n];
return $exts;
} 


/*Report to display the number of times each product viewed from the user side*/


function productViewedReport($product_id,$customer_id)
{
global $tableprefix;

	$select_product = "SELECT nreport_id,dproduct_view_date FROM ".$tableprefix."report_product 
					   WHERE nreport_product_id = ".$product_id."
					    AND nreport_customerid = ".$customer_id.
						" AND dproduct_view_date != NOW()";
			
	$result_product = mysql_query($select_product) or die(mysql_error());
		
	if(mysql_num_rows($result_product) > 0)
	{
		
				
		$product_update = "UPDATE ".$tableprefix."report_product 
						   SET nproduct_view_count = nproduct_view_count + 1,
						    dproduct_view_date = NOW()
						   WHERE nreport_product_id = ".$product_id.
						   " AND nreport_customerid = ".$customer_id;
		mysql_query($product_update) or die(mysql_error());				   
	
	}
	else
	{
		
		$select_product = "SELECT nreport_id,dproduct_view_date FROM ".$tableprefix."report_product 
					   	   WHERE nreport_product_id = ".$product_id.
						   " AND nreport_customerid = ".$customer_id;
								   
		$result_product = mysql_query($select_product) or die(mysql_error());
		
		if(mysql_num_rows($result_product) == 0)
		{
		
			$product_update = "INSERT INTO ".$tableprefix."report_product(nreport_product_id,nreport_customerid,nproduct_view_count,dproduct_view_date)
						   	   VALUES(".$product_id.",".$customer_id.",1,NOW())";
			mysql_query($product_update) or die(mysql_error());				   
		}				   
						   
	}
		
	
}













/*displays the rating star in userside*/

function SellerRatingStar($prd_id,$units='',$static='')
{ 
global $tableprefix,$_SESSION;


	//echo $prd_id;
	
	//exit;
		
	//set some variables
	//$ip = $_SERVER['REMOTE_ADDR'];
	if (!$units) {$units = 10;}
	if (!$static) {$static = FALSE;}
	$rating_unitwidth = 30;

		
	$query = mysql_query("SELECT nrating_id,ntotal_ratings FROM ".$tableprefix."record_ratings WHERE nrseller_id = '$prd_id' AND nruser_id = ".$_SESSION['sess_userid'])or die(" Error: ".mysql_error());
		
	$numbers=mysql_fetch_assoc($query);

	if ($numbers['ntotal_ratings'] < 1)
	{
		$count = 0;
	}
	else
	{
		$count=$numbers['ntotal_ratings']; //how many votes total
	}
		$current_rating = $numbers['ntotal_ratings']; //total number of rating added together and stored
		$tense=($count==1) ? "vote" : "votes"; //plural form votes/vote

	// determine whether the user has voted, so we know how to draw the ul/li

	
	$voted = mysql_num_rows(mysql_query("SELECT nrts_id FROM ".$tableprefix."record_ratings WHERE nrseller_id = '$prd_id' AND nruser_id = ".$_SESSION['sess_userid'])); 
				
	// now draw the rating bar
	$rating_width = @number_format($numbers['nrating_id'])*$rating_unitwidth;

	$rating1 = @number_format($current_rating/$count,1);
	$rating2 = @number_format($current_rating/$count,2);

		
	$select_seller_rating = "SELECT nrat_id,vrating FROM ".$tableprefix."rating WHERE 1";
	$result_seller_rating = mysql_query($select_seller_rating);	
    $units = mysql_num_rows($result_seller_rating);
	  
    $rater ='';
    $rater.='<div class="ratingblock">';
    $rater.='<div id="unit_long'.$prd_id.'">';
	$rater.='<ul id="unit_ul'.$prd_id.'" class="unit-rating" style="width:'.$rating_unitwidth*$units.'px;">';
	$ncount = 1;
	  
	while($rating_row = mysql_fetch_array($result_seller_rating ))
	{
	  
	  	$rater.='<li class="current-rating" style="width:'.$rating_width.'px;">Currently '.$rating2.'/'.$units.'</li>';
	  	$rating_id = $rating_row['nrat_id'];
	  
	  	   
	  	   if(!$voted)
		   { 
		   
		  
		   
		   		// if the user hasn't yet voted, draw the voting stars
            	$rater.='<li><a href="#?q='.$prd_id.'&amp;rating='.$rating_id.'&amp;c='.$units.'"title="'.$rating_row['vrating'].'" class="r'.$ncount.'-unit rater" rel="nofollow">'.$ncount.'</a></li>';
		 			  
           }
					
	 $ncount ++;	
	 }	  
     
		 	 
	  $select_rating_count = mysql_query("SELECT SUM(ntotal_ratings) AS rating_total FROM ".$tableprefix."record_ratings WHERE nrseller_id = ".$prd_id);
	  $rating_count = mysql_fetch_assoc($select_rating_count);
	 
      $ncount=0; // resets the count
      $rater.='  </ul>';
      $rater.='  <p';
	  if($voted){ $rater.=' class="voted"'; }
      $rater.='>Total Ratings :'.$rating_count['rating_total'];
      $rater.='  </p>';
	  $rater.='  </td></tr></table>';
      $rater.='</div>';
      $rater.='</div>';
      return $rater;

}



/*function to get the site general settings*/


function getSiteGeneralSettings($field_array)
{
global $tableprefix;

	/* Example
	
		$check_array = array('vgooglecheck_id','vgooglecheck_key','vgooglecheck_mode');
		$settings = getSiteGeneralSettings($check_array);
	
	*/


	$settings_array = array();
	$result_array = join($field_array,',');	
	
	$select_settings_fields = "SELECT ".$result_array." FROM ".$tableprefix."settings WHERE 1";
	$result_settings_fields = mysql_query($select_settings_fields) or die(mysql_error());
	
	$settings_row = mysql_fetch_assoc($result_settings_fields);
	
	for($i=0;$i<count($field_array);$i++)
	{
	
		array_push($settings_array,$settings_row[$field_array[$i]]);
		
	
	}
	
return $settings_array;
}


/*function to restrict the unauthorized access*/


function checkDownloadAuthorize()
{
global $_SESSION;

	if(!isset($_SESSION['SESS_download']))
	{
	
		header('Location:digital_product_download.php');
		exit;
		
	}


}


/*function to activate the currency type*/


function activateCurrencyType($table_id)
{
global $tableprefix;

	if($table_id != "")
	{

		$update_currency_type = "UPDATE ".$tableprefix."currency_master SET vactive = 'Y' WHERE ncurrency_id = ".$table_id;
		mysql_query($update_currency_type) or die(mysql_error());
		
		$update_currency_type = "UPDATE ".$tableprefix."currency_master SET vactive = 'N' WHERE ncurrency_id != ".$table_id;
		mysql_query($update_currency_type) or die(mysql_error());
	}

}



/*function to check whether shipping is enabled or not*/

function checkShippingEnable()
{
global $tableprefix;

	$select_settings = "SELECT enable_shipping FROM ".$tableprefix."settings WHERE 1";
	$result_settings = mysql_query($select_settings) or die(mysql_error());
	$settings_row = mysql_fetch_assoc($result_settings);

return $settings_row['enable_shipping']; 
}



/*function to activate the template*/


/*function activateTemplate($table_id)
{
global $tableprefix;

	if($table_id != "")
	{

		$update_template = "UPDATE ".$tableprefix."template_master SET vactive_status = 'Y' WHERE ntemplate_id = ".$table_id;
		mysql_query($update_template) or die(mysql_error());
		
		$update_template = "UPDATE ".$tableprefix."template_master SET vactive_status = 'N' WHERE ntemplate_id != ".$table_id;
		mysql_query($update_template) or die(mysql_error());
	}

}*/




/*function to display the currency symbol and calculate the price based on the exchange price*/


function displayCurrencyType()
{
global $tableprefix,$_SESSION;

	$currency_array = array();
	
	if(isset($_SESSION['SESS_currency_type']) or $_SESSION['SESS_currency_type'] != "")
	{
	
		$select_currency_type = "SELECT vcurrency_symbol,nexchange_price,vcurrency_code FROM ".$tableprefix."currency_master 
								 WHERE ncurrency_id = ".$_SESSION['SESS_currency_type'];
	
	}
	else
	{
	
		$select_currency_type = "SELECT vcurrency_symbol,nexchange_price,vcurrency_code FROM ".$tableprefix."currency_master 
								 WHERE vactive = 'Y'";
	
	}

	
	$result_currency_type = mysql_query($select_currency_type) or die(mysql_error());
	
	$currency_row = mysql_fetch_assoc($result_currency_type);
	array_push($currency_array,$currency_row['vcurrency_symbol'],$currency_row['nexchange_price'],$currency_row['vcurrency_code']);
	
return $currency_array; 
}






/*function to display the active template*/


function displayTemplate()
{
global $tableprefix,$_SESSION;
	
	
	$template_array = array();
	
	$select_template = "SELECT vtop_filename,vleft_filename,vbottom_filename,vimages_folder,vcss_name
					    FROM ".$tableprefix."template_master WHERE vactive_status = 'Y'";
	$result_template = mysql_query($select_template) or die(mysql_error());
	$template_row = mysql_fetch_assoc($result_template);
	
	array_push($template_array,$template_row['vtop_filename'],$template_row['vleft_filename'],$template_row['vbottom_filename'],$template_row['vimages_folder'],$template_row['vcss_name']);
	
return $template_array; 
}










/*function to get the general site settings value*/

function getSettingsValue($field_name)
{
global $tableprefix;

	$select_settings_value = "SELECT ".$field_name." FROM ".$tableprefix."settings WHERE 1";
	$result_settings_value = mysql_query($select_settings_value) or die(mysql_error()); 

	$settings_row = mysql_fetch_assoc($result_settings_value);
	
	
return $settings_row[$field_name]; 
}



/*function to generate a random gift coupon code*/


function randomGiftCouponKey() 
{ 
global $tableprefix;

	$string = ""; 
	$possible_charactors = "PaNbIuJcMOfgnTopRUjkXlSmFxGqrdeKsLvzAwyBZDtEhiHQVWCY";

	while(strlen($string)<2) 
	{ 
		 $string .= substr($possible_charactors, rand()%(strlen($possible_charactors)),2); 
	} 	
	$string .=	gmdate("mdYHis").substr(microtime(),2,6);
	$string	=	str_replace("-","",$string);
	$string	=	str_replace(":","",$string);
	$string	=	str_replace(" ","",$string);
	
	$select_gift_coupon = "SELECT ngift_id FROM ".$tableprefix."giftcoupon_master WHERE vgift_coupon_code  = '".$string."'";
	$result_gift_coupon = mysql_query($select_gift_coupon);
	if(mysql_num_rows($result_gift_coupon) > 0)
	{ $string = randomKey(); }
 
return($string); 
}





/*function to generate a random digital product zip file name*/


function randomDigitalProduct() 
{ 
global $tableprefix;

	$string = ""; 
	$possible_charactors = "PaNbIuJcMOfgnTopRUjkXlSmFxGqrdeKsLvzAwyBZDtEhiHQVWCY";

	while(strlen($string)<2) 
	{ 
		 $string .= substr($possible_charactors, rand()%(strlen($possible_charactors)),2); 
	} 	
	$string .=	gmdate("mdYHis").substr(microtime(),2,6);
	$string	=	str_replace("-","",$string);
	$string	=	str_replace(":","",$string);
	$string	=	str_replace(" ","",$string);
	
	$select_digital_product = "SELECT ndigital_id FROM ".$tableprefix."digital_product WHERE vdigital_product_name = '".$string."'";
	$result_digital_product = mysql_query($select_digital_product);
	if(mysql_num_rows($result_digital_product) > 0)
	{ $string = randomKey(); }
 
return($string); 
}


/*function to display banner in the home page*/

function displayBannerHome($bannner_id)
{
global $tableprefix;

	$update_banner_display_count = "UPDATE ".$tableprefix."banners 
									SET nbanner_display_count = nbanner_display_count + 1 
									WHERE nbanner_id = ".$bannner_id;
	mysql_query($update_banner_display_count) or die(mysql_error());									


}



function ImageTypeBanner($image)
{
	list($width, $height, $type, $attr) = @getimagesize($image);
	switch ($type) {
					case 1 :
									$returntype = "gif";
									break;
					case 2 :
									$returntype = "jpg";
									break;
					case 3 :
									$returntype = "png";
									break;
					case 4 :
									$returntype = "swf";
									break;
					case 5 :
									$returntype = "psd";
									break;
					case 6 :
									$returntype = "bmp";
									break;
								case 7 :
												$returntype = "tiff";
												break;
								case 8 :
												$returntype = "tiff";
												break;
								default :
												$returntype = "notsupportted" ;
												break;
	} 

	return $returntype . ":$width:$height";
	}



/*----------------function to resize the image starts-----------------------*/



function generateThumbNail($src,$dest,$x,$y)
{
global $save_to_file,$image_quality,$image_type,$max_x,$max_y,$from_name,$to_name; 
 
	// Below are default values (if parameter is not passed)
	
					   
	// save to file (true) or output to browser (false)
	$save_to_file = true;
	
	// quality
	$image_quality = 100;
	
	// resulting image type (1 = GIF, 2 = JPG, 3 = PNG)
	// enter code of the image type if you want override it
	// or set it to -1 to determine automatically
	$image_type = -1;
	
	// maximum thumb side size
	$max_x = 100;
	$max_y = 100;
								
						
	///////////////////////////////////////////////////
	/////////////// DO NOT EDIT BELOW
	///////////////////////////////////////////////////
	
	$to_name   = '';
	$from_name = str_replace(" ","%20",$src);						
	$to_name   = $dest;
	$max_x     = $x;
	$max_y     = $y;
										
							
								
// generate
return GenerateThumbFile($from_name, $to_name, $max_x, $max_y);		
}						
							
							
function SaveImage($type, $im, $filename, $quality, $to_file = true)
{

  $res = null;
									  
  // ImageGIF is not included into some GD2 releases, so it might not work
  // output png if gifs are not supported
  if(!function_exists('imagegif')) $type = 3;

  switch ($type) {
																			
	case 1:
	  if ($to_file) {
		$res = ImageGIF($im,$filename);								           
	  }
	  else {
		header("Content-type: image/gif");
		$res = ImageGIF($im);
	  }
	  break;
	case 2:
	  if ($to_file) {
		$res = ImageJPEG($im,$filename,$quality);
	  }
	  else {
		header("Content-type: image/jpeg");
		$res = ImageJPEG($im,'',$quality);
	  }
	  break;
	case 3:
	  if ($to_file) {
		$res = ImagePNG($im,$filename);
	  }
	  else {
		header("Content-type: image/png");
		$res = ImagePNG($im,'',$quality);
	  }
	  break;
  }

  return $res;

}
								
function ImageCreateFromType($type,$filename) {

 $im = null;
 switch ($type) {
   case 1:
	 $im = @imagecreatefromgif($filename);
	break;
   case 2:
	 $im = @imagecreatefromjpeg($filename);
	break;
   case 3:
     $im = @imagecreatefrompng($filename);
	break;
  }
  
  //header("Content-Type: image/png");
//$img = LoadPNG("bogus.image");
  return $im;
}
								
// generate thumb from image and save it
function GenerateThumbFile($from_name, $to_name, $max_x, $max_y)
{
global $save_to_file, $image_type, $image_quality;

		
	   $image_flag = 0;
	   $resize_flag = 0;

	  // get source image size (width/height/type)
	  // orig_img_type 1 = GIF, 2 = JPG, 3 = PNG
	  list($orig_x, $orig_y, $orig_img_type, $img_sizes) = GetImageSize($from_name);
	  
	  
	  /*echo "original x =".$orig_x."<br>";
	  echo "original y =".$orig_y."<br>";
	  echo "image sizes =".$img_sizes."<br>";
	  
	  echo "max x =".$max_x."<br>";
	  echo "max y =".$max_y."<br>";
	  
	  exit;*/
	  
	  //$a = GetImageSize($from_name);
	  
	 	
	  // should we override thumb image type?
	  $image_type = ($image_type != -1 ? $image_type : $orig_img_type);
	  
	 // check for allowed image types
	  if ($orig_img_type < 1 or $orig_img_type > 3) die("Image type not supported");
	  
	  
	  if ($orig_x < $max_x or $orig_y < $max_y)
	  {
	  	
		$resize_flag = 1;
		  
	  	//header('Location:'.$_SERVER['HTTP_REFERER']);
	   // exit;
	  	  
	  //return $resize_flag;
	  }
	  
	  if($resize_flag != 1)
	  {
	  
			
			  if ($orig_x > $max_x or $orig_y > $max_y) {
			  
				
			  
			/*-------if original image size is less than the specified size to resize no need to resize------------- */	  
			
						
				
				/*$per_x = $orig_x / $max_x;
				$per_y = $orig_y / $max_y;
				if ($per_y > $per_x)
				{
				  $max_x = $orig_x / $per_y;
				}
				else
				{
				  $max_y = $orig_y / $per_x;
				}*/
			
			}
				
			
			
			else {
			// keep original sizes, i.e. just copy
			if ($save_to_file) {
			  @copy($from_name, $to_name);
			  
				 // echo "testing";
				
				//exit;
			}
			else {
						
			  switch ($image_type) {
				case 1:
					header("Content-type: image/gif");
					include($from_name);
				  break;
				case 2:
					header("Content-type: image/jpeg");
					include($from_name);
				  break;
				case 3:
					header("Content-type: image/png");
					include($from_name);
				 break;
			  }
			}
			return;
			}
	
	
			//if($resize_flag == 0)
			//{
			
																	
					if ($image_type == 1) {
					// should use this function for gifs (gifs are palette images)
					$ni = imagecreate($max_x, $max_y);
					
					//echo "1ni=".$ni;
						
						//exit;
					
					}
					else {
					// Create a new true color image
					$ni = ImageCreateTrueColor($max_x,$max_y);
					
						//echo "2ni=".$ni;
						
						//exit;
							
					}
		
		
					// Fill image with white background (255,255,255)
					$white = imagecolorallocate($ni, 255, 255, 255);
					imagefilledrectangle( $ni, 0, 0, $max_x, $max_y, $white);
					// Create a new image from source file
								
					$im = ImageCreateFromType($orig_img_type,$from_name); 
					
					if(!$im)
					{
					
						$image_flag = 1;
						
						
					}
					else
					{	
			
						//imagepng($im);
								
						// Copy the palette from one image to another
						imagepalettecopy($ni,$im);
						// Copy and resize part of an image with resampling
														
						imagecopyresampled(
						$ni, $im,             // destination, source
						0, 0, 0, 0,           // dstX, dstY, srcX, srcY
						$max_x, $max_y,       // dstW, dstH
						$orig_x, $orig_y);    // srcW, srcH
						
						// save thumb file
						
						
																					  
					  SaveImage($image_type, $ni, $to_name, $image_quality, $save_to_file);
				// }	  
				 
			}	  
		
	}		
	
	return $image_flag; 	
			
										  
}



/*----------------function to resize the image ends-----------------------*/


function stripslashes_deep($value)
{
	if (is_array($value)) {
		array_map('stripslashes_deep', $value);
	} else if (is_object($value)) {
		$value	= $value;
	} else {
		stripslashes($value);
	}
//    $value = is_array($value) ? array_map('stripslashes_deep', $value) : stripslashes($value);
    return $value;
}
function isValidEmail($email)
{
    $email = trim($email);
    if ($email == "") {
        return false;
    }
    if (!eregi("^" . "[a-z0-9]+([_\\.-][a-z0-9]+)*" . // user
            "@" . "([a-z0-9]+([\.-][a-z0-9]+)*)+" . // domain
            "\\.[a-z]{2,}" . // sld, tld
            "$", $email, $regs)) {
        return false;
    } else {
        return true;
    }
}
function isValidUsername($str)
{
    if (trim($str) != "") {
        if (eregi ("[^0-9a-zA-Z+_]", $str)) {
            return false;
        } else {
            return true;
        }
    } else {
        return false;
    }
}
function onlyChars($str)
{
    if (eregi ("[^a-zA-Z]", $str)) {
        return false;
    } else {
        return true;
    }
}
function isNotNull($value)
{
    if (is_array($value)) {
        if (sizeof($value) > 0) {
            return true;
        } else {
            return false;
        }
    } else {
        if (($value != '') && (strtolower($value) != 'null') && (strlen(trim($value)) > 0)) {
            return true;
        } else {
            return false;
        }
    }
}

function pageBrowser($totalrows, $numLimit, $amm, $queryStr, $numBegin, $start, $begin, $num)
{
    $larrow = "&nbsp;<<&nbsp;"; //You can either have an image or text, eg. Previous
    $rarrow = "&nbsp;>>&nbsp;"; //You can either have an image or text, eg. Next
    $wholePiece = ""; //This appears in front of your page numbers
    if ($totalrows > 0) {
        $numSoFar = 1;
        $cycle = ceil($totalrows / $amm);
        if (!isset($numBegin) || $numBegin < 1) {
            $numBegin = 1;
            $num = 1;
        }
        if (!isset($start) || $start < 0) {
            $minus = $numBegin-1;
            $start = $minus * $amm;
        }
        if (!isset($begin)) {
            $begin = $start;
        }
        $preBegin = $numBegin - $numLimit;
        $preStart = $amm * $numLimit;
        $preStart = $start - $preStart;
        $preVBegin = $start - $amm;
        $preRedBegin = $numBegin-1;
        if ($start > 0 || $numBegin > 1) {
            $wholePiece .= "<a class=links href='?num=" . $preRedBegin
             . "&start=" . $preStart
             . "&numBegin=" . $preBegin
             . "&begin=" . $preVBegin
             . $queryStr . "'><font class=navigate>"
             . $larrow . "</a></font>\n";
        }
        for ($i = $numBegin;$i <= $cycle;$i++) {
            if ($numSoFar == $numLimit + 1) {
                $piece = "<a class=links href='?numBegin=" . $i
                 . "&num=" . $i
                 . "&start=" . $start
                 . $queryStr . "'><font class=navigate>"
                 . $rarrow . "</font></a>\n";
                $wholePiece .= $piece;
                break;
            }
            $piece = "<a  class=links href='?begin=" . $start
             . "&num=" . $i
             . "&numBegin=" . $numBegin
             . $queryStr
             . "'>";
            if ($num == $i) {
                $piece .= "<b><font id=navigate class=navigate>$i</font></b>";
            } else {
                $piece .= "<font id=navigate class=navigate>$i</font>";
            }
            $piece .= "</a>\n";
            $start = $start + $amm;
            $numSoFar++;
            $wholePiece .= $piece;
        }
        $wholePiece .= "\n";
        $wheBeg = $begin + 1;
        $wheEnd = $begin + $amm;
        $wheToWhe = "<b>" . $wheBeg . "</b> - <b>";
        if ($totalrows <= $wheEnd) {
            $wheToWhe .= $totalrows . "</b>";
        } else {
            $wheToWhe .= $wheEnd . "</b>";
        }
        $sqlprod = " LIMIT " . $begin . ", " . $amm;
    } else {
        $wholePiece = "<p align=center class=text_information><font size='2'>Sorry, no records to display.</font><br>&nbsp;</p>";
        $wheToWhe = "<b>0</b> - <b>0</b>";
    }

    return array($sqlprod, $wheToWhe, $wholePiece);
}
if (!function_exists('array_combine')) {
    function array_combine($a1, $a2)
    {
        if (count($a1) != count($a2))
            return false;
        if (count($a1) <= 0)
            return false;
        $a1 = array_values($a1);
        $a2 = array_values($a2);
        $output = array();
        for($i = 0; $i < count($a1); $i++) {
            $output[$a1[$i]] = $a2[$i];
        }
        return $output;
    }
}

function dateFormat($input_date, $input_format, $output_format)
{
    preg_match("/^([\w]*)/i", $input_date, $regs);
    $sep = substr($input_date, strlen($regs[0]), 1);
    $label = explode($sep, $input_format);
    $value = explode($sep, $input_date);
    $array_date = array_combine($label, $value);
    if (in_array('Y', $label)) {
        $year = $array_date['Y'];
    } elseif (in_array('y', $label)) {
        $year = $year = $array_date['y'];
    } else {
        return false;
    }

    $output_date = date($output_format, mktime(0, 0, 0, $array_date['m'], $array_date['d'], $year));
    return $output_date;
}
function datediff($interval, $datefrom, $dateto, $using_timestamps = false)
{
    /*
    $interval can be:
    yyyy - Number of full years
    q - Number of full quarters
    m - Number of full months
    y - Difference between day numbers
      (eg 1st Jan 2004 is "1", the first day. 2nd Feb 2003 is "33". The datediff is "-32".)
    d - Number of full days
    w - Number of full weekdays
    ww - Number of full weeks
    h - Number of full hours
    n - Number of full minutes
    s - Number of full seconds (default)
  */
    if (!$using_timestamps) {
        $datefrom = strtotime($datefrom, 0);
        $dateto = strtotime($dateto, 0);
    }
    $difference = $dateto - $datefrom; // Difference in seconds
    switch ($interval) {
        case 'yyyy': // Number of full years
            $years_difference = floor($difference / 31536000);
            if (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom), date("j", $datefrom), date("Y", $datefrom) + $years_difference) > $dateto) {
                $years_difference--;
            }
            if (mktime(date("H", $dateto), date("i", $dateto), date("s", $dateto), date("n", $dateto), date("j", $dateto), date("Y", $dateto) - ($years_difference + 1)) > $datefrom) {
                $years_difference++;
            }
            $datediff = $years_difference;
            break;
        case "q": // Number of full quarters
            $quarters_difference = floor($difference / 8035200);
            while (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom) + ($quarters_difference * 3), date("j", $dateto), date("Y", $datefrom)) < $dateto) {
                $months_difference++;
            }
            $quarters_difference--;
            $datediff = $quarters_difference;
            break;
        case "m": // Number of full months
            $months_difference = floor($difference / 2678400);
            while (mktime(date("H", $datefrom), date("i", $datefrom), date("s", $datefrom), date("n", $datefrom) + ($months_difference), date("j", $dateto), date("Y", $datefrom)) < $dateto) {
                $months_difference++;
            }
            $months_difference--;
            $datediff = $months_difference;
            break;
        case 'y': // Difference between day numbers
            $datediff = date("z", $dateto) - date("z", $datefrom);
            break;
        case "d": // Number of full days
            $datediff = floor($difference / 86400);
            break;
        case "w": // Number of full weekdays
            $days_difference = floor($difference / 86400);
            $weeks_difference = floor($days_difference / 7); // Complete weeks
            $first_day = date("w", $datefrom);
            $days_remainder = floor($days_difference % 7);
            $odd_days = $first_day + $days_remainder; // Do we have a Saturday or Sunday in the remainder?
            if ($odd_days > 7) { // Sunday
                $days_remainder--;
            }
            if ($odd_days > 6) { // Saturday
                $days_remainder--;
            }
            $datediff = ($weeks_difference * 5) + $days_remainder;
            break;
        case "ww": // Number of full weeks
            $datediff = floor($difference / 604800);
            break;
        case "h": // Number of full hours
            $datediff = floor($difference / 3600);
            break;
        case "n": // Number of full minutes
            $datediff = floor($difference / 60);
            break;
        default: // Number of full seconds (default)
            $datediff = $difference;
            break;
    }
    return $datediff;
}
/*
function makeDropDownList($ddlname, $list, $selectedindex, $emptyrequired, $class, $properties, $behaviors)
{
    $ddl = "";
    $ddl .= "<select name=\"$ddlname\" class=\"$class\"";
    if (isNotNull($properties)) {
        $ddl .= " \"$properties\"";
    }
    if (isNotNull($behaviors)) {
        $ddl .= " $behaviors ";
    }
    $ddl .= " >";
    if ($emptyrequired) {
        $ddl .= "<option value=''";
        $ddl .= "></option>\n";
    }
    if (count($list) > 0) {
        foreach($list as $key => $value) {
            $ddl .= "<option value=\"$key\"";
            if(is_array($selectedindex)){
                if (in_array("$key", $selectedindex)) {
                    $ddl .= " selected=\"selected\"";
                }
            }else{
                if ($selectedindex == "$key") {
                    $ddl .= " selected=\"selected\"";
                }
            }

            $ddl .= ">" . htmlentities($value) . "</option>\n";
        }
    }
    $ddl .= "</select>";
    return $ddl;
}
*/
function makeDropDownList($ddlname, $list, $selectedindex, $emptyrequired, $class, $properties, $behaviors)
{
    $ddl = "";
    $properties = trim($properties);
    $class = trim($class);
    $properties = trim($properties);
    $behaviors = trim($behaviors);

    $ddl .= "<select  name=\"$ddlname\" class=\"$class\" ";
    if ($properties != "") {
        $ddl .= "  $properties  ";
    }
    if ($behaviors != "") {
        $ddl .= " $behaviors ";
    }
    $ddl .= " >";
    if ($emptyrequired) {
        $ddl .= "<option value=''";
        $ddl .= "></option>\n";
    }
    if (count($list) > 0) {
        foreach($list as $key => $value) {
            $ddl .= "<option value= \"" . htmlentities($key) . "\" ";
            if (is_array($selectedindex)) {
                if (in_array("$key", $selectedindex)) {
                    $ddl .= " selected=\"selected\"";
                }
            } else {
                if ($selectedindex == "$key") {
                    $ddl .= " selected=\"selected\"";
                }
            }
            if(strlen($value)>50)
			  $value=substr($value,0,50 )."......";

            $ddl .= ">" . htmlentities($value) . "</option>\n";
        }
    }
    $ddl .= "</select>";
    return $ddl;
}

function makeCountryList()
{
    global $tableprefix;
    static $options;
    $sql = " SELECT country_iso_code_2 as val, country_name FROM " . $tableprefix . "countries ";
    $resoptions = mysql_query($sql);
    $numoptions = mysql_num_rows($resoptions);
    if ($numoptions > 0) {
        while (list($stid, $stname) = mysql_fetch_row($resoptions)) {
            $options[$stid] = $stname ;
        }
    }
    return $options;
}

function makeArtistList()
{
    global $tableprefix;
    static $options;
    $sql = " SELECT artist_id,artist_name FROM " . $tableprefix . "artists ";
    $resoptions = mysql_query($sql);
    $numoptions = mysql_num_rows($resoptions);
    if ($numoptions > 0) {
        while (list($stid, $stname) = mysql_fetch_row($resoptions)) {
            $options[$stid] = $stname ;
        }
    }
    return $options;
}
function makeAffiliateList()
{
    global $tableprefix;
    static $options;
    $sql = " SELECT affiliate_id,affiliate_name FROM " . $tableprefix . "affiliates ";
    $resoptions = mysql_query($sql);
    $numoptions = mysql_num_rows($resoptions);
    if ($numoptions > 0) {
        while (list($stid, $stname) = mysql_fetch_row($resoptions)) {
            $options[$stid] = $stname ;
        }
    }
    return $options;
}

// //
// Break a word in a string if it is longer than a specified length ($len)
function break_string($string, $len, $break_char = '-')
{
    $l = 0;
    $output = '';
    for ($i = 0, $n = strlen($string); $i < $n; $i++) {
        $char = substr($string, $i, 1);
        if ($char != ' ') {
            $l++;
        } else {
            $l = 0;
        }
        if ($l > $len) {
            $l = 1;
            $output .= $break_char;
        }
        $output .= $char;
    }

    return $output;
}

function sanitize_string($string)
{
    $string = ereg_replace(' +', ' ', trim($string));

    return preg_replace("/[<>]/", '_', $string);
}

function getCategoryLink($baseurl, $catid)
{
    global $tableprefix;
    $link = "<a class='links' href='" . $baseurl . "' class=boldtextblack>Categories</a> ";
    if ($catid != "") {
        $link .= "<font class=\"links\">></font>";
        $sql = "SELECT * FROM `" . $tableprefix . "categories` where category_id = '" . $catid . "'";
        $result = mysql_query($sql);
        if (mysql_num_rows($result) != 0) {
            $row = mysql_fetch_array($result);
            $currcatid = $row["category_id"];
            $currcatname = $row["category_name"];
            $subcats = $row["route"];
        }
        if ($subcats == "") {
            $lastcat = "<a class='links' href='" . $baseurl . "?catid=" . $currcatid . "'><b>" . htmlentities($currcatname) . "</b></a>";
        } else {
            $sql = "SELECT * FROM `" . $tableprefix . "categories` where category_id in ($subcats) ";
            $result = mysql_query($sql);
            if (mysql_num_rows($result) != 0) {
                while ($row = mysql_fetch_array($result)) {
                    $subcatname = $row["category_name"];
                    $subcatid = $row["category_id"];
                    $link .= " <a class='links' href='" . $baseurl . "?catid=" . $subcatid . "'  >" . htmlentities($subcatname) . "</a><font class=boldtextblack> ></font>";
                }
            }
            $link = substr($link, 0, -35);
        }
    }

    $link .= $lastcat;
    return $link;
}



function getCategoryLinkNew($baseurl, $catid)
{
    global $tableprefix;
   // $link = "<a href='" . $baseurl . "'>Categories</a> ";
   
      
    if ($catid != "") {
        $link .= " >> ";
		
        $sql = "SELECT * FROM `" . $tableprefix . "categories` where category_id = '" . $catid . "'";
        $result = mysql_query($sql);
        if (mysql_num_rows($result) != 0) {
            $row = mysql_fetch_array($result);
            $currcatid = $row["category_id"];
            $currcatname = $row["category_name"];
            $subcats = $row["route"];
        }
        if ($subcats == "") {
            $lastcat = "<a href='" . $baseurl . "?catid=" . $currcatid . "'>" . htmlentities($currcatname) . "</a>";
        } else {
            $sql = "SELECT * FROM `" . $tableprefix . "categories` where category_id in ($subcats) ";
            $result = mysql_query($sql);
            if (mysql_num_rows($result) != 0) {
                while ($row = mysql_fetch_array($result)) {
                    $subcatname = $row["category_name"];
                    $subcatid = $row["category_id"];
                    $link .= " <a  href='" . $baseurl . "?catid=" . $subcatid . "'>" . htmlentities($subcatname) . "</a><font class=boldtextblack>>></font>";
                }
            }
            $link = substr($link, 0, -35);
        }
    }

    $link .= $lastcat;
    return $link;
}





function isParentCategory($catid)
{
    global $tableprefix;
    $sql = "SELECT category_id FROM `" . $tableprefix . "categories` where parent_id = '" . $catid . "'";
    $result = mysql_query($sql);
    if (mysql_num_rows($result) != 0) {
        return true;
    } else {
        return false;
    }
}

function isRootCategory($catid)
{
    global $tableprefix;
    $sql = "SELECT parent_id FROM `" . $tableprefix . "categories` where category_id = '" . $catid . "'";
    $result = mysql_query($sql);
    if (mysql_num_rows($result) != 0) {
        $row = mysql_fetch_array($result);
        $pid = $row["parent_id"];
        if (($pid == "") || ($pid == 0)) {
            return true;
        } else {
            return false;
        }
    }
    return false;
}

function categoryHasProducts($catid)
{
    global $tableprefix;
    $sql = "SELECT product_category FROM `" . $tableprefix . "products` where product_category = '" . $catid . "' ";
    $result = mysql_query($sql);
    if (mysql_num_rows($result) != 0) {
        return true;
    }
    return false;
}
function categoryHasChildren($catid)
{
    global $tableprefix;
    $sql = "SELECT category_id FROM `" . $tableprefix . "categories` where parent_id  = '" . $catid . "'";
    $result = mysql_query($sql);
    if (mysql_num_rows($result) != 0) {
        return true;
    }
    return false;
}
function isCategoryDeletable($catid)
{
    global $tableprefix;
    $sql = "SELECT parent_id FROM `" . $tableprefix . "categories` where category_id = '" . $catid . "'";
    $result = mysql_query($sql);
    if (mysql_num_rows($result) != 0) {
        return false;
    }
    $sql = "SELECT category_id FROM `" . $tableprefix . "products` where category_id = '" . $catid . "'";
    $result = mysql_query($sql);
    if (mysql_num_rows($result) != 0) {
        return false;
    }
    return true;
}

function make_selectlist($current_cat_id, $count)
{
    global $tableprefix;
    static $option_results;
    if (!isset($current_cat_id)) {
        $current_cat_id = 0;
    }
    $count = $count + 1;
    $sql = "SELECT category_id as id, category_name as name,gift_certificate_flag
		    FROM " . $tableprefix . "categories WHERE parent_id = '" . addslashes($current_cat_id) . "' ORDER BY name ASC ";
    $get_options = mysql_query($sql);
    $num_options = mysql_num_rows($get_options);
    if ($num_options > 0)
	{
        while (list($cat_id, $cat_name, $gift_flag) = mysql_fetch_row($get_options))
		{
            
/*-------Multicart 2.0 Upgradation------------*/			

			if($gift_flag == "Y")
			{
			
				$select_gift_products = "SELECT product_id FROM ".$tableprefix."products
														 WHERE product_category = ".$cat_id;
														 
				$result_gift_products = mysql_query($select_gift_products) or die(mysql_error());						
				
				if(mysql_num_rows($result_gift_products) > 0)
				{			
				
					if ($current_cat_id != 0)
					{
						$indent_flag = "   ";
						for ($x = 2; $x <= $count; $x++)
						{
							$indent_flag .= " --> ";
						}
					}
					$cat_name = $indent_flag . $cat_name;
					$option_results[$cat_id] = $cat_name;
					make_selectlist($cat_id, $count);
				
				
				
				}
			
			}
			else
			{		
			
				if ($current_cat_id != 0)
				{
					$indent_flag = "   ";
					for ($x = 2; $x <= $count; $x++)
					{
						$indent_flag .= " --> ";
					}
				}
				$cat_name = $indent_flag . $cat_name;
				$option_results[$cat_id] = $cat_name;
				make_selectlist($cat_id, $count);
				
			}
			
				
        }
    }
    return $option_results;
}

function getCategoryDescendants($catid)
{
    global $tableprefix;
    static $option_results;
    static $i=0;
    $option_results[$i] = $catid;
    $i++;

/*---Mulicart 2.0 Upgradation-------*/	
	
	$sql = "SELECT category_id FROM `" . $tableprefix . "categories` where parent_id = " . $catid;
			
    $result = mysql_query($sql) or die(mysql_error());
	
/*---Mulicart 2.0 Upgradation-------*/	
	
    if (mysql_num_rows($result) != 0) {
        while($row = mysql_fetch_array($result) ){
            getCategoryDescendants($row["category_id"]);
        }
    }
    return $option_results;
}

function categoryExists($catname, $parentcatid)
{
    global $tableprefix;
    $sql = "SELECT category_id FROM `" . $tableprefix . "categories` where category_name = '" . addslashes($catname) . "' AND parent_id = '" . $parentcatid . "'";
    $result = mysql_query($sql);
    if (mysql_num_rows($result) != 0) {
        return true;
    } else {
        return false;
    }
}


function getProductStock($pid)
{
    global $tableprefix;
    $sql = "SELECT product_stock FROM `" . $tableprefix . "products` where product_id = '" . $pid . "' ";

    $result = mysql_query($sql);
    if (mysql_num_rows($result) != 0) {
        $rw = mysql_fetch_array($result);
        return $rw["product_stock"];
    }
    return 0;
}
function adjustQuantities($userid)
{
    global $tableprefix;
    $sql = "SELECT * FROM " . $tableprefix . "cart WHERE user_id = '" . addslashes($userid) . "' ";
    $result = mysql_query($sql);
    $parr = array();
    $itemcount = 0;
    if (mysql_num_rows($result) != 0) {
        while ($row = mysql_fetch_array($result)) {
            $parr[$itemcount]["cartid"] = $row["cart_id"];
            $parr[$itemcount]["productid"] = $row["product_id"];
            $parr[$itemcount]["quantity"] = $row["quantity"];
            $itemcount++;
        }
    }
    $qtyadjusted = false;
    for($i = 0; $i < $itemcount;$i++) {
        $cartid = $parr[$i]["cartid"];
        $productid = $parr[$i]["productid"];
        $value = $parr[$i]["quantity"];
        $qtyavailable = getProductStock($productid);
        if ($qtyavailable == 0) { // soldout, so delete the item from the cart
            $sql = "DELETE FROM " . $tableprefix . "cart WHERE cart_id='" . addslashes($cartid) . "' ";
            mysql_query($sql);
            $qtyadjusted = true;
        } else if ($value > $qtyavailable) {
            $sql = "UPDATE " . $tableprefix . "cart SET quantity = '" . addslashes($qtyavailable) . "' WHERE cart_id='" . addslashes($cartid) . "' ";
            mysql_query($sql);
            $qtyadjusted = true;
            $qtyavailable = 0;
        }
    }
    return $qtyadjusted;
}
function adjustStock($userid, $mode)
{
    global $tableprefix;
    $sql = "SELECT * FROM " . $tableprefix . "cart WHERE user_id = '" . addslashes($userid) . "' ";
    $result = mysql_query($sql);
    $parr = array();
    $itemcount = 0;
    if (mysql_num_rows($result) != 0) {
        while ($row = mysql_fetch_array($result)) {
            $parr[$itemcount]["cartid"] = $row["cart_id"];
            $parr[$itemcount]["productid"] = $row["product_id"];
            $parr[$itemcount]["quantity"] = $row["quantity"];
            $itemcount++;
        }
    }
    $stockadjusted = false;
    for($i = 0; $i < $itemcount;$i++) {
        $cartid = $parr[$i]["cartid"];
        $productid = $parr[$i]["productid"];
        $value = $parr[$i]["quantity"];
        $qtyavailable = getProductStock($productid);
        if ($mode == "+") {
            $newstock = $qtyavailable + $value;
			$sqlstatus = "UPDATE  " . $tableprefix . "cart SET status='0' WHERE user_id = '" . addslashes($userid) . "' ";
        } else if ($mode == "-") {
            $newstock = $qtyavailable - $value;
			$sqlstatus = "UPDATE  " . $tableprefix . "cart SET status='1' WHERE user_id = '" . addslashes($userid) . "' ";
        }

        if ($newstock >= 0) {
            $sql = "UPDATE " . $tableprefix . "products SET product_stock = '" . addslashes($newstock) . "' WHERE product_id='" . addslashes($productid) . "' ";
            mysql_query($sql);
            $stockadjusted = true;
            $qtyavailable = 0;
        }
    }
	mysql_query($sqlstatus) ;
    return $stockadjusted;
}

function getCheckoutExpiredUsers()
{
    global $tableprefix;
	$timenow = time();
	$oneday = 86400;

	$timeyday = $timenow - $oneday;
    $sql = "SELECT DISTINCT user_id FROM " . $tableprefix . "cart  WHERE datetime_added < '" . addslashes($timeyday) . "' AND status='1' ";
    //$sql = "SELECT DISTINCT user_id FROM " . $tableprefix . "cart  WHERE status='1' ";
    //echo $sql;
    $result = mysql_query($sql);
	$eusers = "";
    if (mysql_num_rows($result) > 0) {
        while($row = mysql_fetch_array($result)){
			$eusers .=",".$row["user_id"];
		}
		$eusers = substr($eusers,1);
    }
    return $eusers;
}


function getCartTotal($userid)
{
    global $tableprefix;
    $sql = "SELECT c.*, p.product_price,p.discount FROM " . $tableprefix . "cart c INNER JOIN " . $tableprefix . "products p ON p.product_id = c.product_id WHERE c.user_id = '" . addslashes($userid) . "' ";
    $result = mysql_query($sql);
    $total = 0;
    $itemcount = 0;
    if (mysql_num_rows($result) != 0) {
        while ($row = mysql_fetch_array($result)) {
		    $price = $row["quantity"] * $row["product_price"];

			if($row["discount"] !="0"){
			$price=$price- ($price*$row["discount"])/100;
			}
  			$total += $price;
        }
    }
    return $total;
}
function emptyCart($userid)
{
    global $tableprefix;
    $sql = "DELETE FROM " . $tableprefix . "cart  WHERE user_id = '" . addslashes($userid) . "' ";
    $result = mysql_query($sql);
    return;
}
function isCartEmpty($userid)
{
    global $tableprefix;
    $sql = "SELECT cart_id FROM " . $tableprefix . "cart  WHERE user_id = '" . addslashes($userid) . "' ";
    $result = mysql_query($sql);
    if (mysql_num_rows($result) > 0) {
        return false;
    }
    return true;
}
function isVisitorCartEmpty($visitorid)
{
    global $tableprefix;
    $sql = "SELECT cart_id FROM " . $tableprefix . "cart  WHERE visitor_cart_id = '" . addslashes($visitorid) . "' ";
    $result = mysql_query($sql);
    if (mysql_num_rows($result) > 0) {
        return false;
    }
    return true;
}

function mergeVisitorCartToUserCart($visitorid,$userid){
    global $tableprefix;
	$usercart = array();
	$visitorcart = array();
    $sql = "SELECT cart_id, product_id, quantity FROM " . $tableprefix . "cart  WHERE visitor_cart_id = '" . addslashes($visitorid) . "' ";
    $result = mysql_query($sql);
    if (mysql_num_rows($result) > 0) {
		$todelete = "";
		while($row = mysql_fetch_array($result)){
			$vcartid = $row["cart_id"];
			$productid = $row["product_id"];
			$quantity = $row["quantity"];
			$sql2 = "SELECT cart_id, product_id, quantity FROM " . $tableprefix . "cart  WHERE user_id = '" . addslashes($userid) . "'  AND product_id = '".addslashes($productid)."'";
			//echo "<br>".$sql2."<br>";
		    $result2 = mysql_query($sql2);
		    if (mysql_num_rows($result2) > 0) {//the same product is present in usercart
				$row2 = mysql_fetch_array($result2);
				$todelete .=",".$vcartid;
				$usercartid = $row2["cart_id"];
				$userquantity =$row2["quantity"];
				$newqty = $userquantity+$quantity;
				$sql4 = "UPDATE " . $tableprefix . "cart SET visitor_cart_id='',quantity='".$newqty."'  WHERE cart_id= '".addslashes($usercartid)."' ";
				//echo $sql4."<br>";
				mysql_query($sql4);
			}else{
				$sql5 = "UPDATE " . $tableprefix . "cart SET visitor_cart_id='', user_id='".addslashes($userid)."',quantity='".$quantity."'  WHERE cart_id= '".addslashes($vcartid)."' ";
				//echo $sql5."<br>";
				mysql_query($sql5);
			}

		}
    	$todelete = substr($todelete,1);
		if($todelete !=""){
			$sql6 = "DELETE FROM " . $tableprefix . "cart  WHERE cart_id IN (".addslashes($todelete).") ";
				//echo $sql6."<br>";
				mysql_query($sql6);
		}

    }

	return true;
}

function getStatusList()
{
    global $tableprefix;
    static $options;
    $sql = " SELECT order_status_id, order_status FROM " . $tableprefix . "order_status ";
    $resoptions = mysql_query($sql);
    $numoptions = mysql_num_rows($resoptions);
    if ($numoptions > 0) {
        while (list($stid, $stname) = mysql_fetch_row($resoptions)) {
            $options[$stid] = $stname ;
        }
    }
    return $options;
}

function getOrderArtists($oid)
{
    global $tableprefix;
    $artists = array();
    $cnt = 0;

    $sql = " SELECT artist_id FROM " . $tableprefix . "order_details WHERE order_id = '" . addslashes($oid) . "' ";
    //echo $sql;
    $resoptions = mysql_query($sql);
    if (mysql_num_rows($resoptions) > 0) {
        while ($rw = mysql_fetch_array($resoptions)) {
            $artists[$cnt] = $rw["artist_id"];
            $cnt++;
        }
    }
    // $artists = array_unique(array_values($artists));
    $artists = array_unique($artists);
    return implode(",", $artists);
}
function getArtistName($sid)
{
    global $tableprefix;
    $sql = "SELECT artist_name FROM `" . $tableprefix . "artists` where artist_id = '" . $sid . "' ";
    $result = mysql_query($sql);
    if (mysql_num_rows($result) != 0) {
        $rw = mysql_fetch_array($result);
        return $rw["artist_name"];
    }
    return "";
}
function getAffiliateName($aid)
{
    global $tableprefix;
    $sql = "SELECT affiliate_name FROM `" . $tableprefix . "affiliates` where affiliate_id = '" . $aid . "' ";
    $result = mysql_query($sql);
    if (mysql_num_rows($result) != 0) {
        $rw = mysql_fetch_array($result);
        return $rw["affiliate_name"];
    }
    return "";
}
function getArtistOrderStatus($oid, $sid)
{
    global $tableprefix;
    $cnt = 0;

    $sql = "SELECT s.order_status FROM " . $tableprefix . "order_details od
            INNER JOIN " . $tableprefix . "order_status s ON od.item_status = s.order_status_id
            AND od.artist_id = '" . addslashes($sid) . "'
            WHERE order_id = '" . addslashes($oid) . "' ";
    $resoptions = mysql_query($sql);
    // echo $sql;
    if (mysql_num_rows($resoptions) > 0) {
        $rw = mysql_fetch_array($resoptions);
        $status = $rw["order_status"] ;
    }
    return $status;
}

function getOrderStatus($oid)
{
    global $tableprefix;
    $cnt = 0;
    $statuses = array();
    $sql = "SELECT s.order_status FROM " . $tableprefix . "order_details od
            INNER JOIN " . $tableprefix . "order_status s ON od.item_status = s.order_status_id
            WHERE order_id = '" . addslashes($oid) . "' ";
    $resoptions = mysql_query($sql);
    // echo $sql;
    if (mysql_num_rows($resoptions) > 0) {
        while ($rw = mysql_fetch_array($resoptions)) {
            $statuses[$cnt] = $rw["order_status"];
            $cnt++;
        }
    }
    $statuses = array_unique(array_values($statuses));
    if (count($statuses) == 1) {
        return $statuses[0];
    } else {
        $status = implode(" / ", $statuses);
        return $status;
    }
}
function getClientIP()
{
    // Get REMOTE_ADDR as the Client IP.
    $client_ip = (!empty($_SERVER['REMOTE_ADDR'])) ? $_SERVER['REMOTE_ADDR'] : ((!empty($_ENV['REMOTE_ADDR'])) ? $_ENV['REMOTE_ADDR'] : $REMOTE_ADDR);
    // Check for headers used by proxy servers to send the Client IP. We should look for HTTP_CLIENT_IP before HTTP_X_FORWARDED_FOR.
    if ($_SERVER["HTTP_CLIENT_IP"])
        $proxy_ip = $_SERVER["HTTP_CLIENT_IP"];
    elseif ($_SERVER["HTTP_X_FORWARDED_FOR"])
        $proxy_ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
    // Proxy is used, see if the specified Client IP is valid. Sometimes it's 10.x.x.x or 127.x.x.x... Just making sure.
    if ($proxy_ip) {
        if (preg_match("/^([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)/", $proxy_ip, $ip_list)) {
            $private_ip = array('/^0\./', '/^127\.0\.0\.1/', '/^192\.168\..*/', '/^172\.16\..*/', '/^10.\.*/', '/^224.\.*/', '/^240.\.*/');
            $client_ip = preg_replace($private_ip, $client_ip, $ip_list[1]);
        }
    }
    // Return the Client IP.
    return $client_ip;
}

function isValidWebImageType($mimetype)
{
		   	
	if (($mimetype == "image/pjpeg") || ($mimetype == "image/jpeg") || ($mimetype == "image/x-png") || ($mimetype == "image/png") || ($mimetype == "image/gif")){
        return true;
    } else {
        return false;
    }
}


function NewimageCreatefromtype($image){
  list($width, $height, $type, $attr) = @getimagesize($image);
  if($type=="1"){  //gif
    $returnimage=@imagecreatefromgif($image);
  }else if($type=="2"){ //jpeg
    $returnimage=@imagecreatefromjpeg($image);
  }else if($type=="3"){ //png
    $returnimage=@imagecreatefrompng($image);
  }else {
     $returnimage="Not Supported";
  }
  return $returnimage;
}
function Imagetype($newImage,$newfile,$editimagefile){
  list($width, $height, $type, $attr) = @getimagesize($editimagefile);
  $jpgCompression="60";
  if($type=="1"){  //gif
    $returnimage= @imagegif($newImage, '');
  }else if($type=="2"){ //jpeg
    $returnimage=@imagejpeg($newImage, '', $jpgCompression);;
  }else if($type=="3"){ //png
    $returnimage= @imagepng($newImage,'');
  }else {
    $returnimage="Not Supported";
  }
  return $returnimage;
}
/*function getResizedImage($file,$img_height) {
  $img_temp = NewimageCreatefromtype($file);
  $black = @imagecolorallocate ($img_temp, 0, 0, 0);
  $white = @imagecolorallocate ($img_temp, 255, 255, 255);
  $font = 2;
  $img_width=@imagesx($img_temp)/imagesy($img_temp)*$img_height;
  $img_thumb=@imagecreatetruecolor($img_width,$img_height);
  @imagecopyresampled($img_thumb,$img_temp,0,0,0,0,$img_width,$img_height,@imagesx ($img_temp),@imagesy($img_temp));
  $originx = @imagesx($img_thumb) - 100;
  $originy = @imagesy($img_thumb) - 15;
  header ("Content-type: image/jpeg");
  imagejpeg($img_thumb, '', 60);
}*/
function getResizedImage($file, $img_height)
{
				list($originalwidth, $originalheight, $originaltype) = getimagesize($file);
				$img_temp = NewimageCreatefromtype($file);
				$black = @imagecolorallocate ($img_temp, 0, 0, 0);
				$white = @imagecolorallocate ($img_temp, 255, 255, 255);
				$font = 2;
				$img_width = @imagesx($img_temp) / imagesy($img_temp) * $img_height;
				if ($originaltype == "1") { // gif
								$newwidth = $img_width;
								$newheight = $img_height;
								$tpcolor = imagecolorat($img_temp, 0, 0);
								// in the real world, you'd better test all four corners, not just one!
								$img_thumb = imagecreate($newwidth, $newheight);
								// $dest automatically has a black fill...
								imagepalettecopy($img_thumb, $img_temp);
								imagecopyresized($img_thumb, $img_temp, 0, 0, 0, 0, $newwidth, $newheight,
												@imagesx ($img_temp), @imagesy($img_temp));
								$pixel_over_black = imagecolorat($img_thumb, 0, 0);
								// ...but now make the fill white...
								$bg = imagecolorallocate($img_thumb, 255, 255, 255);
								imagefilledrectangle($img_thumb, 0, 0, $newwidth, $newheight, $bg);
								imagecopyresized($img_thumb, $img_temp, 0, 0, 0, 0, $newwidth, $newheight,
												@imagesx ($img_temp), @imagesy($img_temp));
								$pixel_over_white = imagecolorat($img_thumb, 0, 0);
								// ...to test if transparency causes the fill color to show through:
								if ($pixel_over_black != $pixel_over_white) {
												// Background IS transparent
												imagefilledrectangle($img_thumb, 0, 0, $newwidth, $newheight,
																$tpcolor);
												imagecopyresized($img_thumb, $img_temp, 0, 0, 0, 0, $newwidth,
																$newheight, @imagesx ($img_temp), @imagesy($img_temp));
												imagecolortransparent($img_thumb, $tpcolor);
												imagegif($img_thumb);
								} else // Background (most probably) NOT transparent
												imagegif($img_thumb);
				} else {
								$img_thumb = @imagecreatetruecolor($img_width, $img_height);
								@imagecopyresampled($img_thumb, $img_temp, 0, 0, 0, 0, $img_width, $img_height, @imagesx ($img_temp), @imagesy($img_temp));
								$originx = @imagesx($img_thumb) - 100;
								$originy = @imagesy($img_thumb) - 15;
								header ("Content-type: image/jpeg");
								imagejpeg($img_thumb, '', 60);
				}
}
function getCategory($baseurl, $catid)
{
    global $tableprefix;
    $link = "";
	$append="NO";
    if ($catid != "") {
        $link .= "<font class=boldtextblack>></font>";
        $sql = "SELECT * FROM `" . $tableprefix . "categories` where category_id = '" . $catid . "'";
        $result = mysql_query($sql);
        if (mysql_num_rows($result) != 0) {
            $row = mysql_fetch_array($result);
            $currcatid = $row["category_id"];
            $currcatname = $row["category_name"];
            $subcats = $row["route"];
        }
        if ($subcats == "") {
            $lastcat = "<b>" . htmlentities($currcatname) . "</b>";
        } else {
            $sql = "SELECT * FROM `" . $tableprefix . "categories` where category_id in ($subcats) ";
            $result = mysql_query($sql);
            if (mysql_num_rows($result) != 0) {
                while ($row = mysql_fetch_array($result)) {
                    $subcatname = $row["category_name"];
                    $subcatid = $row["category_id"];
                    $link .= "<b>" . htmlentities($subcatname) . "</b>";
					$link =$link. "<font class=boldtextblack> ></font>";
		        }
            }
            $link = substr($link, 0, -35);
        }
    }

    $link .= $lastcat;
	$link = substr($link, 37);

    return $link;
}
function makeDropDownList_search($ddlname, $list, $selectedindex, $emptyrequired, $class, $properties, $behaviors)
{
    $ddl = "";
    $properties = trim($properties);
    $class = trim($class);
    $properties = trim($properties);
    $behaviors = trim($behaviors);

    $ddl .= "<select  name=\"$ddlname\" class=\"$class\" ";
    if ($properties != "") {
        $ddl .= "  $properties  ";
    }
    if ($behaviors != "") {
        $ddl .= " $behaviors ";
    }
    $ddl .= " >";
    if ($emptyrequired) {
        $ddl .= "<option value=''";
        $ddl .= "></option>\n";
    }
    if (count($list) > 0) {
        foreach($list as $key => $value) {
            $ddl .= "<option value= \"" . htmlentities($key) . "\" ";
            if (is_array($selectedindex)) {
                if (in_array("$key", $selectedindex)) {
                    $ddl .= " selected=\"selected\"";
                }
            } else {
                if ($selectedindex == "$key") {
                    $ddl .= " selected=\"selected\"";
                }
            }
            if(strlen($value)>20)
			  $value=substr($value,0,20 )."......";

            $ddl .= ">" . htmlentities($value) . "</option>\n";
        }
    }
    $ddl .= "</select>";
    return $ddl;
}
?>